/************************************************************************
* "Epsilon" is a registered trademark licensed to Lugaru Software, Ltd. *
*		"EEL" and "Lugaru" are trademarks of Lugaru Software, Ltd.		*
*																		*
*  Copyright (C) 1984, 2004 Lugaru Software Ltd.  All rights reserved.	*
*																		*
* Limited permission is hereby granted to reproduce and modify this		*
* copyrighted material provided that the resulting code is used only in *
* conjunction with Lugaru products and that this notice is retained in	*
* any such reproduction or modification.								*
************************************************************************/

// For updating from 12.04 to 12.05.

#include "eel.h"
#include "session.h"
#include "dired.h"

remember_this_buffer()	/* should we record this buffer in session file? */
{
	int limit;

	if (*bufname == '-' || !size())
		return 0;
	if (is_process_buffer(bufnum) || buffer_not_saveable || _read_aborted)
		return 0;
	if (file_info.year && file_info.check_type != CHECK_FILE)
		return 0;
	if (is_dired_buf()) {
		if (!(session_restore_directory_buffers
			  & (is_remote_file(get_dired_buffer_pattern()) ? 2
			: strstr(get_dired_buffer_pattern(), "**") ? 4 : 1)))
			return 0;
	} else {
		if (!*filename)
			return 0;
		limit = is_remote_file(filename) ? session_restore_biggest_remote_file
										 : session_restore_biggest_file;
		if (limit >= 0 && size() > limit)
			return 0;		// too big to restore
	}
	return 1;
}
