/************************************************** -*- tab-width:4 -*- *
* "Epsilon" is a registered trademark licensed to Lugaru Software, Ltd. *
*		"EEL" and "Lugaru" are trademarks of Lugaru Software, Ltd.		*
*																		*
*  Copyright (C) 1985, 2004 Lugaru Software Ltd.  All rights reserved.	*
*																		*
* Limited permission is hereby granted to reproduce and modify this		*
* copyrighted material provided that the resulting code is used only in *
* conjunction with Lugaru products and that this notice is retained in	*
* any such reproduction or modification.								*
************************************************************************/

// Some Unicode-related commands.

#include "eel.h"

do_unicode_convert(int flags)
{
	char msg[FNAMELEN], *enc;
	int err = 0, from = 0, to = size(), high, scol, ecol;

	high = is_highlight_on();
	check_modify(bufnum);
	sprintf(msg, "Convert %s %s", high ? "region" : "buffer",
			(flags & CONV_TO_16) ? "to Unicode from encoding"
								 : "from Unicode to encoding");
	if (!(enc = encoding_to_name(ask_encoding(msg, 1))))
		return;
	if (high) {
		save_spot point, mark;
		fix_region();
		from = point;
		to = mark;
	} else
		save_spot point;
	if (high == REGRECT) {
		scol = get_column(point);
		ecol = get_column(mark);
		for (; point < mark && !err; nl_forward())
			err = perform_unicode_conversion(bufnum, column_to_pos(scol),
											 column_to_pos(ecol), flags, enc);
	} else
		err = perform_unicode_conversion(bufnum, from, to, flags, enc);
	if (err == ETOOBIG)
		error("This is not an 8-bit encoding; a character is already wide.");
	if (!high && (flags & CONV_TO_16)) {
		int trans = GET_LINE_TRANSLATE(translation_type);
		int conv = encoding_from_name(enc);
		translation_type = MAKE_TRANSLATE(conv, trans,
										  (trans != FILETYPE_AUTO || conv > 0));
	}
}

command unicode_convert_from_encoding()
{
	do_unicode_convert(CONV_TO_16);
}

command unicode_convert_to_encoding()
{
	do_unicode_convert(0);
}
